/*
 * @author Venkat Subramaniam
 * DuraSoft, Inc.
 * http://www.durasoftcorp.com/download
 */

using System;
using System.Security.Permissions;
using System.IO;

namespace CodeAccessSecurity
{
	class User
	{
		[STAThread]
		static void Main(string[] args)
		{
			User obj = new User();
			try
			{
				obj.f1();
			}
			catch(Exception e)
			{
				Console.WriteLine("Error: {0}", e.Message);
			}

			try
			{
				obj.testf2_1();
				Console.WriteLine("Cleared testf2_1");
			}
			catch(Exception e)
			{
				Console.WriteLine("Error: {0}", e.Message);
			}

			try
			{
				obj.f3();
			}
			catch(Exception e)
			{
				Console.WriteLine("Error: {0}", e.Message);
			}
		}

		public void f1()
		{
			MyClass obj = new MyClass();
			obj.foo();
		}

		// Security demand may be specified using an attribute as in f2 
		// or using an object as in testf2_1().
		public void testf2_1()
		{
			FileIOPermission perm = new FileIOPermission(PermissionState.Unrestricted);
			perm.Deny();
			f2();
			FileIOPermission.RevertDeny();
		}
	
		// Security demand may be specified using an attribute as in f2 
		// or using an object as in testf2_1().
		[FileIOPermission(SecurityAction.Demand, Unrestricted=true)]
		public void f2()
		{
		}

		public void f3()
		{
			// This method applies security overrides.
			// It demands that the code being called does not access any files.

			FileIOPermission perm = new FileIOPermission(PermissionState.Unrestricted);
			perm.Deny();
			MyClass obj = new MyClass();
			obj.foo();
			FileIOPermission.RevertDeny();
		}
	}
}
